
#include <omnetpp.h>
#include "TCPSocket.h"

class TCPMobileDeviceApp : public cSimpleModule, public TCPSocket::CallbackInterface {
	protected:
		TCPSocket socket;
		int numSessions;
		long bytesSent;
		int packetsSent;
		cMessage *connectMsg;
		cMessage *sendMsg;
		cMessage *moveMsg;

	public:
		TCPMobileDeviceApp();
		virtual ~TCPMobileDeviceApp();

	protected:
    	virtual void initialize();
		virtual void handleMessage(cMessage *msg);
		virtual void handleTimer(cMessage *msg);
		virtual void connect();
		virtual void close();
		virtual void sendData();
		virtual void socketDataArrived(int connId, void *yourPtr, cMessage *msg, bool urgent);
		virtual void socketEstablished(int connId, void *yourPtr);
		virtual void socketPeerClosed(int connId, void *yourPtr);
		virtual void socketClosed(int connId, void *yourPtr);
		virtual void socketFailure(int connId, void *yourPtr, int code);
		virtual void socketStatusArrived(int connId, void *yourPtr, TCPStatusInfo *status) {delete status;}
		virtual void setTag();
		virtual void finish();
		virtual void setErrorRate();
};
